=== debian/changelog ===
maxima (5.46.0-3) unstable; urgency=medium

  * remove locales from build-depends

 -- Camm Maguire <camm@debian.org>  Thu, 11 Aug 2022 10:52:07 -0400

maxima (5.46.0-2) unstable; urgency=medium

  * source-only upload
  * Bug fix: "Please replace or remove mime-support in the Recommends
    section of xmaxima and maxima-emacs", thanks to Charles Plessy
    (Closes: #1010327).

 -- Camm Maguire <camm@debian.org>  Sat, 28 May 2022 10:17:44 -0400

maxima (5.46.0-1) unstable; urgency=medium

  * New upstream release.

 -- Camm Maguire <camm@debian.org>  Sun, 17 Apr 2022 22:07:35 +0000
